; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

	szLen	PROTO	:DWORD
	szCopy	PROTO	:DWORD,:DWORD

.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Add proc pArray:DWORD,pString:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx
	push	esi

	mov		ebx, [esp+3*4]									; pArray
	mov		esi, [esp+4*4]									; pString
	mov		eax, [ebx+_size]								; size
	mov		ecx, [ebx+_index]								; index

	.if		ecx >= eax										; left space?
		mov		eax, -1										; return -1
		jmp		@F
	.endif

	invoke	szLen, esi
	push	eax												; store size
	add		eax, 5											; size + 0 terminator
	invoke	GlobalAlloc, GMEM_FIXED or GMEM_ZEROINIT, eax
	pop		ecx
	test	eax, eax										; no memory?
	jz		@F												; return 0

	mov		[eax], ecx										; store size in memory
	push	eax												; store ptr
	add		eax, 4											; skip size
	invoke	szCopy, esi, eax
	pop		eax
	mov		ecx, [ebx+_index]								; index
	mov		[ebx+ecx*4+_array], eax							; write ptr to array

	add		ecx, 1											; inc index
	mov		[ebx+_index], ecx								; update index
	mov		[ebx+_count], ecx								; update count

	mov		eax, ecx
@@:
	pop		esi
	pop		ebx
	ret		2*4

sa_Add endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

; ###########################################################################

end
