; ###########################################################################
; original source from donkey
; adapted/modified by denise_amiga

.586						; create 32 bit code
.model flat, stdcall		; 32 bit memory model
option casemap :none		; case sensitive

include	windows.inc
include kernel32.inc

	szCompare	PROTO :DWORD,:DWORD
	szComparei	PROTO :DWORD,:DWORD
	
.code

; ###########################################################################

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE

align 4

sa_Compare proc item1:DWORD,item2:DWORD,fAscend:DWORD,fCase:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ecx
	push	esi
	push	eax

	mov		ecx, [esp+4*4]									; item1
	mov		esi, [esp+5*4]									; item2

	mov		edx, [ebx+ecx*4+_reserved]
	test	edx, edx
	jz		@e1

	add		edx, 4											; skip size
	mov		eax, [ebx+esi*4+_reserved]
	test	eax, eax
	jz		@e1

	add		eax, 4											; skip size
	cmp		dword ptr [esp+6*4], 0							; fAscend
	jz		@s1

	cmp		dword ptr [esp+7*4], 0							; fCase
	jz		@F

	invoke	szCompare, eax, edx
	jmp		@e0
@@:
	invoke	szComparei, eax, edx
	jmp		@e0
@s1:
	cmp		dword ptr [esp+7*4], 0							; fCase
	jz		@F

	invoke	szCompare, edx, eax
	jmp		@e0
@@:
	invoke	szComparei, edx, eax
@e0:
	mov		edx, eax

	pop		eax
	pop		esi
	pop		ecx
	ret		4*4

@e1:
	xor		edx, edx

	pop		eax
	pop		esi
	pop		ecx
	ret		4*4

sa_Compare endp

align 4

sa_Exchange proc item1:DWORD,item2:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ecx
	push	esi

	mov		ecx, [esp+3*4]									; item1
	mov		esi, [esp+4*4]									; item2
	mov		edx, [ebx+ecx*4+_reserved]
	push	[ebx+esi*4+_reserved]
	mov		[ebx+esi*4+_reserved], edx
	pop		[ebx+ecx*4+_reserved]

	pop		esi
	pop		ecx
	ret		2*4

sa_Exchange endp

OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

align 4

sa_Sort proc pArray:DWORD,fAscend:DWORD,fCase:DWORD

_index		= 0*4											; \
_count		= 1*4											; | extra
_size		= 2*4											; | data
_reserved	= 3*4											; /
_array		= 4*4											; <- begin array

	push	ebx
	push	esi
	push	edi

	mov		ebx, pArray
	mov		esi, 1
	mov		edi, [ebx+_index]
	call	@Split
	ret

@Split:
	mov		eax, edi
	push	esi
	push	edi
	sub		eax, esi
	jle		@E1

	mov		ecx, esi
	;inc	edi
	add		edi, 1

@L1:
	;inc	esi
	add		esi, 1
	;dec	eax
	sub		eax, 1
	js		@D1

	invoke	sa_Compare, ecx, esi, fAscend, fCase
	test	edx, edx
	js		@L1

@H1:
	;dec	edi
	sub		edi, 1
	;dec	eax
	sub		eax, 1
	js		@D1

	invoke	sa_Compare, ecx, edi, fAscend, fCase
	test	edx, edx
	jns		@H1

	invoke	sa_Exchange, esi, edi
	jmp		@L1

@D1:
	;dec	esi
	sub		esi, 1
	invoke	sa_Exchange, ecx, esi
	cmp		edi, [esp]
	jge		@12

	;dec	esi												; pivot is sorted
	sub		esi, 1
	mov		eax, [esp]
	mov		[esp], esi
	xchg	edi, eax
	xchg	esi, eax
	call	@Split
	pop		edi
	pop		esi
	jmp		@Split

@12:
	pop		edi
	pop		esi
	;dec	edi
	sub		edi, 1
	jmp		@Split

@E1:
	add		esp, 8
	retn

sa_Sort endp

; ###########################################################################

end
